import { NgtCommonAudio, provideCommonAudioRef, NgtObject, provideObjectRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtAudio extends NgtCommonAudio {
    get audioType() {
        return THREE.Audio;
    }
}
NgtAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudio, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAudio.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: NgtAudio, selector: "ngt-audio", providers: [provideCommonAudioRef(NgtAudio)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudio, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-audio',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonAudioRef(NgtAudio)],
                }]
        }] });
class NgtAudioModule {
}
NgtAudioModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAudioModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioModule, declarations: [NgtAudio], exports: [NgtAudio] });
NgtAudioModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAudio],
                    exports: [NgtAudio],
                }]
        }] });

// GENERATED
class NgtPositionalAudio extends NgtCommonAudio {
    get audioType() {
        return THREE.PositionalAudio;
    }
}
NgtPositionalAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudio, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPositionalAudio.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: NgtPositionalAudio, selector: "ngt-positional-audio", providers: [provideCommonAudioRef(NgtPositionalAudio)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudio, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-positional-audio',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonAudioRef(NgtPositionalAudio)],
                }]
        }] });
class NgtPositionalAudioModule {
}
NgtPositionalAudioModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPositionalAudioModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudioModule, declarations: [NgtPositionalAudio], exports: [NgtPositionalAudio] });
NgtPositionalAudioModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudioModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtPositionalAudioModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtPositionalAudio],
                    exports: [NgtPositionalAudio],
                }]
        }] });

class NgtAudioListener extends NgtObject {
    objectInitFn() {
        return new THREE.AudioListener();
    }
    get preObjectInit() {
        return (initFn) => {
            this.set({ appendMode: 'none' });
            initFn();
        };
    }
    postPrepare(audioListener) {
        const { filter, timeDelta } = this.get();
        if (filter != null) {
            audioListener.filter = filter;
        }
        if (timeDelta != null) {
            audioListener.timeDelta = timeDelta;
        }
        const camera = this.store.get((s) => s.camera);
        if (camera) {
            camera.add(audioListener);
        }
    }
    destroy() {
        const camera = this.store.get((s) => s.camera);
        if (camera) {
            camera.remove(this.instance.value);
        }
        super.destroy();
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { filter: true, timeDelta: true });
    }
}
NgtAudioListener.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListener, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAudioListener.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: NgtAudioListener, selector: "ngt-audio-listener", providers: [provideObjectRef(NgtAudioListener)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListener, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-audio-listener',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideObjectRef(NgtAudioListener)],
                }]
        }] });
class NgtAudioListenerModule {
}
NgtAudioListenerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListenerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAudioListenerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListenerModule, declarations: [NgtAudioListener], exports: [NgtAudioListener] });
NgtAudioListenerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListenerModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgtAudioListenerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAudioListener],
                    exports: [NgtAudioListener],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtAudio, NgtAudioListener, NgtAudioListenerModule, NgtAudioModule, NgtPositionalAudio, NgtPositionalAudioModule };
//# sourceMappingURL=angular-three-core-audios.mjs.map
