import { NgZone } from '@angular/core';
import * as THREE from 'three';
import type { NgtInstanceState } from '../abstracts/instance';
import { NgtInstance } from '../abstracts/instance';
import { Ref } from '../ref';
import { NgtStore } from '../stores/store';
import type { AnyConstructor, AnyFunction } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtCommonGeometry<TGeometry extends THREE.BufferGeometry = THREE.BufferGeometry> extends NgtInstance<TGeometry, NgtInstanceState<TGeometry>> {
    abstract get geometryType(): AnyConstructor<TGeometry>;
    set args(v: ConstructorParameters<AnyConstructor<TGeometry>>);
    constructor(zone: NgZone, store: NgtStore, parentRef: AnyFunction<Ref<THREE.Object3D>>, parentHostRef: AnyFunction<Ref<THREE.Object3D>>);
    protected preInit(): void;
    ngOnInit(): void;
    private readonly init;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCommonGeometry<any>, [null, null, { optional: true; skipSelf: true; }, { optional: true; skipSelf: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCommonGeometry<any>, never, never, { "args": "args"; }, {}, never>;
}
