import { AnyConstructor, NumberInput } from '@angular-three/core';
import * as THREE from 'three';
import { NgtMeshStandardMaterial } from '../mesh-standard-material/mesh-standard-material';
import * as i0 from "@angular/core";
export declare class NgtMeshPhysicalMaterial extends NgtMeshStandardMaterial<THREE.MeshPhysicalMaterialParameters, THREE.MeshPhysicalMaterial> {
    static ngAcceptInputType_parameters: THREE.MeshPhysicalMaterialParameters | undefined;
    set clearcoat(clearcoat: NumberInput);
    set clearcoatMap(clearcoatMap: THREE.Texture | null);
    set clearcoatRoughness(clearcoatRoughness: NumberInput);
    set clearcoatRoughnessMap(clearcoatRoughnessMap: THREE.Texture | null);
    set clearcoatNormalScale(clearcoatNormalScale: THREE.Vector2);
    set clearcoatNormalMap(clearcoatNormalMap: THREE.Texture | null);
    set reflectivity(reflectivity: NumberInput);
    set ior(ior: NumberInput);
    set sheen(sheen: NumberInput);
    set sheenColor(sheenColor: THREE.Color);
    set sheenRoughness(sheenRoughness: NumberInput);
    set transmission(transmission: NumberInput);
    set transmissionMap(transmissionMap: THREE.Texture | null);
    set attenuationDistance(attenuationDistance: NumberInput);
    set attenuationColor(attenuationColor: THREE.Color);
    set specularIntensity(specularIntensity: NumberInput);
    set specularColor(specularColor: THREE.Color);
    set specularIntensityMap(specularIntensityMap: THREE.Texture | null);
    set specularColorMap(specularColorMap: THREE.Texture | null);
    get materialType(): AnyConstructor<THREE.MeshPhysicalMaterial>;
    protected get optionFields(): Record<string, boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMeshPhysicalMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtMeshPhysicalMaterial, "ngt-mesh-physical-material", never, { "clearcoat": "clearcoat"; "clearcoatMap": "clearcoatMap"; "clearcoatRoughness": "clearcoatRoughness"; "clearcoatRoughnessMap": "clearcoatRoughnessMap"; "clearcoatNormalScale": "clearcoatNormalScale"; "clearcoatNormalMap": "clearcoatNormalMap"; "reflectivity": "reflectivity"; "ior": "ior"; "sheen": "sheen"; "sheenColor": "sheenColor"; "sheenRoughness": "sheenRoughness"; "transmission": "transmission"; "transmissionMap": "transmissionMap"; "attenuationDistance": "attenuationDistance"; "attenuationColor": "attenuationColor"; "specularIntensity": "specularIntensity"; "specularColor": "specularColor"; "specularIntensityMap": "specularIntensityMap"; "specularColorMap": "specularColorMap"; }, {}, never, ["*"]>;
}
export declare class NgtMeshPhysicalMaterialModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMeshPhysicalMaterialModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtMeshPhysicalMaterialModule, [typeof NgtMeshPhysicalMaterial], never, [typeof NgtMeshPhysicalMaterial]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtMeshPhysicalMaterialModule>;
}
